package com.jtauber.river.model;

import org.eclipse.draw2d.geometry.Point;
import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.IPropertySource;
import org.eclipse.ui.views.properties.TextPropertyDescriptor;

public class Node extends Element implements IPropertySource {

   // serialization version
   static final long serialVersionUID = 3;

   // properties
   public static final String LOCATION = "location";
   public static final String NAME = "name";

   // descriptors for property sheet
   protected static IPropertyDescriptor[] descriptors;
   static {
      descriptors = new IPropertyDescriptor[] {
         new TextPropertyDescriptor(NAME, "Name")};
   }

   // actual fields
   protected Point location = new Point(0, 0);
   protected String name = "Node";

   public void setLocation(Point p) {
      if (this.location.equals(p)) {
         return;
      } 
      this.location = p;
      firePropertyChange(LOCATION, null, p);
   }

   public Point getLocation() {
      return location;
   }
   
   public void setName(String name) {
      if (this.name.equals(name)) {
         return;
      }
      this.name = name;
      firePropertyChange(NAME, null, name);
   }
   
   public String getName() {
      return name;
   }


   //------------------------------------------------------------------------
   // Abstract methods from IPropertySource

   public Object getEditableValue() {
      return this;
   }

   public IPropertyDescriptor[] getPropertyDescriptors() {
      return descriptors;
   }

   public Object getPropertyValue(Object id) {
      if (NAME.equals(id)) {
         return getName();
      }
      else {
         return null;
      }
   }

   public boolean isPropertySet(Object id) {
      return true;
   }

   public void resetPropertyValue(Object id) {
      // do nothing
   }

   public void setPropertyValue(Object id, Object value) {
      if (id == NAME) {
         setName((String)value);
      }
   }
}